/***********************************************************************************************************************
 *
 * blueArgyle - a Java UI for Argyll
 * Copyright (C) 2011-2012 by Tidalwave s.a.s. (http://www.tidalwave.it)
 *
 ***********************************************************************************************************************
 *
 * Licensed under the Apache License, Version 2.0 (the "License"); you may not use this file except in compliance with
 * the License. You may obtain a copy of the License at
 *
 *     http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on
 * an "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations under the License.
 *
 ***********************************************************************************************************************
 *
 * WWW: http://blueargyle.java.net
 * SCM: https://bitbucket.org/tidalwave/blueargyle-src
 *
 **********************************************************************************************************************/
package it.tidalwave.uniformity.ui.impl.measurement.netbeans;

import javax.annotation.Nonnull;
import org.openide.util.lookup.ServiceProvider;
import it.tidalwave.swing.SwingSafeComponentBuilder;
import it.tidalwave.uniformity.ui.measurement.UniformityCheckMeasurementPresentationProvider;
import lombok.extern.slf4j.Slf4j;
import it.tidalwave.uniformity.ui.measurement.UniformityCheckMeasurementPresentation;
import static it.tidalwave.swing.SwingSafeComponentBuilder.*;

/***********************************************************************************************************************
 * 
 * @stereotype Factory
 * 
 * @author  Fabrizio Giudici
 * @version $Id$
 *
 **********************************************************************************************************************/
@ServiceProvider(service=UniformityCheckMeasurementPresentationProvider.class) @Slf4j
public class NetBeansUniformityCheckMeasurementPresentationProvider implements UniformityCheckMeasurementPresentationProvider
  {
    private final SwingSafeComponentBuilder<NetBeansUniformityCheckMeasurementPresentation, UniformityCheckMeasurementPresentation> builder = 
            builderFor(NetBeansUniformityCheckMeasurementPresentation.class, UniformityCheckMeasurementPresentation.class);
    
    @Override @Nonnull
    public UniformityCheckMeasurementPresentation getPresentation()
      {
        return builder.getInstance();
      }
  }
